#ifndef RHINO_C
#define RHINO_C

#include "rhino.h"

void Handle_Rhino(sprite_ptr spr) {
   if (spr->curr_state == WALKING) {
      spr->curr_anim = 23;
      if (spr->h == -1) {
         spr->flipflag = FLIP;
         spr->x_velocity = -60;
         }
      if (spr->h == 1) {
         spr->flipflag = NOFLIP;
         spr->x_velocity = 60;
         }
      if (spr->h == 0) {
         spr->x_velocity = 0;
         }
      if (spr->v == -1) {
         spr->z_velocity = -50;
         }
      if (spr->v == 1) {
         spr->z_velocity = 50;
         }
      if (spr->v == 0) {
         spr->z_velocity = 0;
         }
      }
   if (spr->curr_state == JUMP_ATTACK) {
      spr->curr_state = JUMPING;
      }
   if (spr->curr_state == JUMPING) {
      spr->curr_state = STANDING;
      }
   if (spr->curr_state == ATTACK5) {
      FA_Set_State(spr, ATTACK1);
      spr->var1 = 0;
      }
   if (spr->curr_state == ATTACK4) {
      FA_Set_State(spr, ATTACK1);
      spr->var1 = 0;
      }
   if (spr->curr_state == ATTACK3) {
      FA_Set_State(spr, ATTACK1);
      spr->var1 = 0;
      }
   if (spr->curr_state == ATTACK2) {
      FA_Set_State(spr, ATTACK1);
      spr->var1 = 0;
      }
   if (spr->curr_state == ATTACK1) {
      spr->x_velocity = 0;
      spr->y_velocity = 0;
      spr->z_velocity = 0;
      spr->curr_anim = 25;
      if (spr->anim_done) {
         FA_Set_State(spr, STANDING);
         }
	  if (spr->y < 0 && !Check_Under_Feet(spr)) {
		spr->x_velocity = 0;
		spr->z_velocity = 0;
		FA_Set_State(spr, DROP_FREE);
		}
      }
   if (spr->curr_state == HELD1) {
	  spr->curr_frame = 100;
	  if (spr->hold->curr_state == HOLDING && spr->action_count == 80) {
			FA_Set_State(spr->hold, STANDING);
			FA_Set_State(spr, DROP_FREE);
			spr->hold->hold = NULL;
			spr->hold = NULL;
			}
		spr->action_count++;
		}
   if (spr->curr_state == HELD2) {
	  spr->curr_frame = 100;
	  if (spr->hold->curr_state == HOLDING && spr->action_count == 80) {
			FA_Set_State(spr->hold, STANDING);
			FA_Set_State(spr, DROP_FREE);
			spr->hold->hold = NULL;
			spr->hold = NULL;
			}
		spr->action_count++;
		}
   /* if (spr->curr_state == DROP_FREE) {
	   spr->y_velocity = (spr->action_count * GRAVITY);
	   spr->action_count++;
	   if (spr->y == 0) {
		   FA_Set_State(spr, STANDING);
			}
		} */
   if (spr->curr_state == GET_HIT_STOMACH) {
      spr->curr_frame = 100;
      if (spr->controlled_by == CPU_ENEMY)
         if (spr->action_count == 45) {
            FA_Set_State(spr, STANDING);
            spr->hit_direction = 0;
            }
      }
   if (spr->curr_state == GET_HIT_HEAD) {
      spr->curr_frame = 100;
      if (spr->controlled_by == CPU_ENEMY)
         if (spr->action_count == 45) {
            FA_Set_State(spr, STANDING);
            spr->hit_direction = 0;
            }
      }
   if (spr->curr_state == THROWN) {
		spr->curr_frame = 100;
		}
   if (spr->curr_state == KNOCKED_DOWN) {
      spr->curr_frame = 100;
      }
   if (spr->curr_state == ON_GROUND_BRIEF || spr->curr_state == ON_GROUND || spr->curr_state == DEAD) {
      spr->curr_frame = 101;
      }
   if (spr->curr_state == BOUNCE) {
      spr->curr_frame = 101;
      }
   if (spr->curr_state == ON_GROUND) {
      if (spr->action_count == 110) {
         FA_Set_State(spr, GET_UP);
         spr->hit_direction = 0;
         }
      spr->action_count++;
      }
   if (spr->curr_state == GET_UP) {
      FA_Set_State(spr, STANDING);
	  if (spr->y < 0 && !Check_Under_Feet(spr)) {
		spr->x_velocity = 0;
		spr->z_velocity = 0;
		FA_Set_State(spr, DROP_FREE);
		}
      }
   if (spr->curr_state == STANDING) {
      spr->curr_frame = 100;
      }
   if (spr->curr_state == WAIT_FOR_NEXT_LIFE) {
      spr->curr_frame = 100;
      }
   }

#endif
