#ifndef SCROLLNU_C
#include "scrollnu.h"
#define SCROLLNU_C
#include "readmap9.h"

void Draw_Screen(int startx, int starty) {
	int iy; // ix removed; may become necessary again if I revise this function
	int pix;
	int curr_tile_x, curr_tile_y;
	int curr_tile_in_x, curr_tile_in_y;
	int pre_tile_y;
	int pix_counter, byiy, offsetplus;
	int bg_offset;
	unsigned char wt, wp;
	int horiz_ct;
	unsigned char *dest;
	unsigned char *src;
	if (transparency) {
		curr_tile_x = startx >> 4;
		curr_tile_y = starty >> 4;
		curr_tile_in_x = startx &0x0f;
		curr_tile_in_y = starty &0x0f;
		pre_tile_y = curr_tile_y*row_length;
		wt = level[pre_tile_y+curr_tile_x];
		if (relative_scroll_rate == 0)
			bg_offset = 0;
		else
			bg_offset = (startx/relative_scroll_rate) % (bg_pic->w >> 1);
		if (bg_offset < 0)
			bg_offset += (bg_pic->w >> 1); // >> 1 means div. by 2
		for (iy=0; iy<200; iy++) {
		    horiz_ct=320;
			byiy = by+iy;
			switch(trans_table[wt]) {
              case 0:
                   dest = &double_buffer->line[iy][0];
                   src = &bg_pic->line[byiy][bg_offset];
                   memcpy(dest, src, (16-curr_tile_in_x));
                   break;
              case 1:
                   dest = &double_buffer->line[iy][0];
		             src = &tiles[wt][curr_tile_in_y][curr_tile_in_x];
                   memcpy(dest, src, (16-curr_tile_in_x));
                   break;
              case 2:
                   pix_counter = curr_tile_in_x;
                   offsetplus = bg_offset;
                   for (pix=0; pix<(16-curr_tile_in_x); pix++) {
                       if ((wp=tiles[wt][curr_tile_in_y][pix_counter]))
                          double_buffer->line[iy][pix] = wp;
                       else
                           double_buffer->line[iy][pix] = bg_pic->line[byiy][offsetplus];
                       pix_counter++;
                       offsetplus++;
                       }
                   break;
              }
          horiz_ct-=(16-curr_tile_in_x);
		    curr_tile_x++;
		    wt = level[pre_tile_y+curr_tile_x];
		    while (horiz_ct>15) {
                switch(trans_table[wt]) {
                    case 0:
                         dest = &double_buffer->line[iy][(320-horiz_ct)];
			                src = &bg_pic->line[byiy][bg_offset+(320-horiz_ct)];
			                memcpy(dest, src, 16);
                         break;
                    case 1:
                         dest = &double_buffer->line[iy][(320-horiz_ct)];
			                src = &tiles[wt][curr_tile_in_y][0];
			                memcpy(dest, src, 16);
                         break;
                    case 2:
                         pix_counter = 320-horiz_ct;
                         offsetplus = bg_offset+pix_counter;
                         for (pix=0; pix<16; pix++) {
                             if ((wp=tiles[wt][curr_tile_in_y][pix]))
                                double_buffer->line[iy][pix_counter] = wp;
                             else
                                 double_buffer->line[iy][pix_counter] = bg_pic->line[byiy][offsetplus];
                             pix_counter++;
                             offsetplus++;
                             }
                         break;
                    }
                horiz_ct-=16;
			       curr_tile_x++;
			       wt = level[pre_tile_y+curr_tile_x];
			       }
          switch(trans_table[wt]) {
              case 0:
                   dest = &double_buffer->line[iy][(320-horiz_ct)];
                   src = &bg_pic->line[by+iy][bg_offset+(320-horiz_ct)];
                   memcpy(dest, src, horiz_ct);
                   break;
              case 1:
		             dest = &double_buffer->line[iy][(320-horiz_ct)];
		             src = &tiles[wt][curr_tile_in_y][0];
		             memcpy(dest, src, horiz_ct);
                   break;
              case 2:
                   pix_counter = 320-horiz_ct;
                   offsetplus = bg_offset+pix_counter;
                   for (pix=0; pix<horiz_ct; pix++) {
                       if ((wp=tiles[wt][curr_tile_in_y][pix]))
                          double_buffer->line[iy][pix_counter] = wp;
                       else
                           double_buffer->line[iy][pix_counter] = bg_pic->line[byiy][offsetplus];
                       pix_counter++;
                       offsetplus++;
                       }
                   break;
              }
          curr_tile_in_y++;
		    if (curr_tile_in_y == 16) {
			    curr_tile_in_y = 0;
			    curr_tile_y++;
			    pre_tile_y+=row_length;
			    }
          curr_tile_x = startx >> 4;
		    curr_tile_in_x = startx &0x0f;
		    wt = level[(pre_tile_y)+curr_tile_x];
		    }
      }
   else {
      curr_tile_x = startx >> 4;
	   curr_tile_y = starty >> 4;
	   curr_tile_in_x = startx & 0x0f;
	   curr_tile_in_y = starty & 0x0f;
	   wt = level[(curr_tile_y*row_length)+curr_tile_x];
	   for (iy=0; iy<200; iy++) {
		    horiz_ct=320;
          dest = &double_buffer->line[iy][0];
		    src = &tiles[wt][curr_tile_in_y][curr_tile_in_x];
		    memcpy(dest, src, (16-curr_tile_in_x));
		    horiz_ct-=(16-curr_tile_in_x);
		    curr_tile_x++;
		    wt = level[(curr_tile_y*row_length)+curr_tile_x];
		    while (horiz_ct>15) {
              dest = &double_buffer->line[iy][(320-horiz_ct)];
			     src = &tiles[wt][curr_tile_in_y][0];
			     memcpy(dest, src, 16);
			     horiz_ct-=16;
			     curr_tile_x++;
			     wt = level[(curr_tile_y*row_length)+curr_tile_x];
			     }
          dest = &double_buffer->line[iy][(320-horiz_ct)];
		    src = &tiles[wt][curr_tile_in_y][0];
		    memcpy(dest, src, horiz_ct);
		    curr_tile_in_y++;
		    if (curr_tile_in_y == 16) {
			    curr_tile_in_y = 0;
			    curr_tile_y++;
			    wt = level[(curr_tile_y*row_length)+curr_tile_x];
			    }
          curr_tile_x = startx >> 4;
		    curr_tile_in_x = startx & 0x0f;
		    wt = level[(curr_tile_y*row_length)+curr_tile_x];
		    }
      }
	}

#endif
